Unit aeg2e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAE10_p;

procedure aeg2e(N :Integer; var A :Array of Extended;
                var EVR :Array of Extended; var EVI :Array of Extended;
                var IERR :Integer);

implementation

procedure aeg2e(N :Integer; var A :Array of Extended;
                var EVR :Array of Extended; var EVI :Array of Extended;
                var IERR :Integer);
var
IR1,IR2,B,C,D,E,F,G,H,K,L,M,O,P,Q,R,S,T,U,V,W :Integer;
I,J,X,Y,Z,BA,BB,BC,BD,BE,BF,BG :Extended;
BI :Boolean;
const
SYS051 :Extended = 2.220446049250313e-16;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34;
begin
IR1 := 1;
IR2 := N;
E := IR2-1;
F := IR1+1;
if ( E < F ) 
 then goto _9;
for D:=F to E do
 begin
  G := D-1;
  I := 0.e0;
  B := D;
  for C:=D to IR2 do
   begin
    if ( Abs(A[(C-1)+(G-1)*N]) <= Abs(I) ) 
     then goto _1;
    I := A[(C-1)+(G-1)*N];
    B := C;
_1:
   end;
  if ( B = D ) 
   then goto _4;
  for C:=G to N do
   begin
    J := A[(B-1)+(C-1)*N];
    A[(B-1)+(C-1)*N] := A[(D-1)+(C-1)*N];
    A[(D-1)+(C-1)*N] := J;
_2:
   end;
  for C:=1 to IR2 do
   begin
    J := A[(C-1)+(B-1)*N];
    A[(C-1)+(B-1)*N] := A[(C-1)+(D-1)*N];
    A[(C-1)+(D-1)*N] := J;
_3:
   end;
_4:
  if ( I = 0.e0 ) 
   then goto _8;
  H := D+1;
  for B:=H to IR2 do
   begin
    J := A[(B-1)+(G-1)*N];
    if ( J = 0.e0 ) 
     then goto _7;
    J := J/I;
    A[(B-1)+(G-1)*N] := J;
    for C:=D to N do
     begin
_5:
      A[(B-1)+(C-1)*N] := A[(B-1)+(C-1)*N]-J*A[(D-1)+(C-1)*N];
     end;
    for C:=1 to IR2 do
     begin
_6:
      A[(C-1)+(D-1)*N] := A[(C-1)+(D-1)*N]+J*A[(C-1)+(B-1)*N];
     end;
_7:
   end;
_8:
 end;
_9:
IERR := 0;
BG := 0.0e0;
M := 1;
for K:=1 to N do
 begin
  for L:=M to N do
   begin
_10:
    BG := BG+Abs(A[(K-1)+(L-1)*N]);
   end;
  M := K;
  if ( K >= IR1 ) and ( K <= IR2 ) 
   then goto _11;
  EVR[K-1] := A[(K-1)+(K-1)*N];
  EVI[K-1] := 0.0e0;
_11:
 end;
Q := IR2;
BB := 0.0e0;
_12:
if ( Q < IR1 ) 
 then goto _34;
U := 0;
T := Q-1;
W := T-1;
_13:
for R:=IR1 to Q do
 begin
  O := Q+IR1-R;
  if ( O = IR1 ) 
   then goto _15;
  BA := Abs(A[(O-2)+(O-2)*N])+Abs(A[(O-1)+(O-1)*N]);
  if ( BA = 0.0e0 ) 
   then BA := BG;
  if ( Abs(A[(O-1)+(O-2)*N]) <= SYS051*BA ) 
   then goto _15;
_14:
 end;
_15:
BD := A[(Q-1)+(Q-1)*N];
if ( O = Q ) 
 then goto _29;
BE := A[(T-1)+(T-1)*N];
BC := A[(Q-1)+(T-1)*N]*A[(T-1)+(Q-1)*N];
if ( O = T ) 
 then goto _30;
if ( U = 30 ) 
 then goto _33;
if ( U <> 10 ) and ( U <> 20 ) 
 then goto _17;
BB := BB+BD;
for K:=IR1 to Q do
 begin
_16:
  A[(K-1)+(K-1)*N] := A[(K-1)+(K-1)*N]-BD;
 end;
BA := Abs(A[(Q-1)+(T-1)*N])+Abs(A[(T-1)+(W-1)*N]);
BD := 0.75e0*BA;
BE := BD;
BC := -0.4375e0*BA*BA;
_17:
U := U+1;
for S:=O to W do
 begin
  P := W+O-S;
  BF := A[(P-1)+(P-1)*N];
  Z := BD-BF;
  BA := BE-BF;
  X := (Z*BA-BC)/A[(P+0)+(P-1)*N]+A[(P-1)+(P+0)*N];
  Y := A[(P+0)+(P+0)*N]-BF-Z-BA;
  Z := A[(P+1)+(P+0)*N];
  BA := Abs(X)+Abs(Y)+Abs(Z);
  X := X/BA;
  Y := Y/BA;
  Z := Z/BA;
  if ( P = O ) 
   then goto _19;
  if ( Abs(A[(P-1)+(P-2)*N])*(Abs(Y)+Abs(Z)) <= SYS051*Abs(X)*
       (Abs(A[(P-2)+(P-2)*N])+Abs(BF)+Abs(A[(P+0)+(P+0)*N]) )) 
   then goto _19;
_18:
 end;
_19:
V := P+2;
for K:=V to Q do
 begin
  A[(K-1)+(K-3)*N] := 0.0e0;
  if ( K = V ) 
   then goto _20;
  A[(K-1)+(K-4)*N] := 0.0e0;
_20:
 end;
for M:=P to T do
 begin
  BI := ( M <> T );
  if ( M = P ) 
   then goto _21;
  X := A[(M-1)+(M-2)*N];
  Y := A[(M+0)+(M-2)*N];
  Z := 0.0e0;
  if ( BI ) 
   then Z := A[(M+1)+(M-2)*N];
  BD := Abs(X)+Abs(Y)+Abs(Z);
  if ( BD = 0.0e0 ) 
   then goto _28;
  X := X/BD;
  Y := Y/BD;
  Z := Z/BD;
_21:
  BA := Sign(Sqrt(X*X+Y*Y+Z*Z),X);
  if ( M = P ) 
   then goto _22;
  A[(M-1)+(M-2)*N] := -BA*BD;
  goto _23;
_22:
  if ( O <> P ) 
   then A[(M-1)+(M-2)*N] := -A[(M-1)+(M-2)*N];
_23:
  X := X+BA;
  BD := X/BA;
  BE := Y/BA;
  BF := Z/BA;
  Y := Y/X;
  Z := Z/X;
  for L:=M to Q do
   begin
    X := A[(M-1)+(L-1)*N]+Y*A[(M+0)+(L-1)*N];
    if ( not BI ) 
     then goto _24;
    X := X+Z*A[(M+1)+(L-1)*N];
    A[(M+1)+(L-1)*N] := A[(M+1)+(L-1)*N]-X*BF;
_24:
    A[(M+0)+(L-1)*N] := A[(M+0)+(L-1)*N]-X*BE;
    A[(M-1)+(L-1)*N] := A[(M-1)+(L-1)*N]-X*BD;
_25:
   end;
  L := Min0(Q,M+3);
  for K:=O to L do
   begin
    X := BD*A[(K-1)+(M-1)*N]+BE*A[(K-1)+(M+0)*N];
    if ( not BI ) 
     then goto _26;
    X := X+BF*A[(K-1)+(M+1)*N];
    A[(K-1)+(M+1)*N] := A[(K-1)+(M+1)*N]-X*Z;
_26:
    A[(K-1)+(M+0)*N] := A[(K-1)+(M+0)*N]-X*Y;
    A[(K-1)+(M-1)*N] := A[(K-1)+(M-1)*N]-X;
_27:
   end;
_28:
 end;
goto _13;
_29:
EVR[Q-1] := BD+BB;
EVI[Q-1] := 0.0e0;
Q := T;
goto _12;
_30:
X := (BE-BD)/2.0e0;
Y := X*X+BC;
BF := Sqrt(Abs(Y));
BD := BD+BB;
if ( Y < 0.0e0 ) 
 then goto _31;
BF := X+Sign(BF,X);
EVR[T-1] := BD+BF;
EVR[Q-1] := EVR[T-1];
if ( BF <> 0.0e0 ) 
 then EVR[Q-1] := BD-BC/BF;
EVI[T-1] := 0.0e0;
EVI[Q-1] := 0.0e0;
goto _32;
_31:
EVR[T-1] := BD+X;
EVR[Q-1] := BD+X;
EVI[T-1] := BF;
EVI[Q-1] := -BF;
_32:
Q := W;
goto _12;
_33:
IERR := Q;
_34:
if ( IERR <> 0 ) 
 then UTAE10(IERR,N,32);
end;

end.
